#ifndef _PROTOTYPES_H
#define _PROTOTYPES_H

/* control.c */
struct control_struct * init_control_struct(struct control_struct ** ctrl_chain);
void finish_control_struct(struct control_struct * ctrl);
int read_control_packet(struct control_struct * ctrl);

int handle_start_ctrl_conn_rqst(struct control_struct * ctrl, struct pptp_start_ctrl_conn_rqst * packet);
int handle_start_ctrl_conn_rply(struct control_struct * ctrl, struct pptp_start_ctrl_conn_rply * packet);
int handle_stop_ctrl_conn_rqst(struct control_struct * ctrl, struct pptp_stop_ctrl_conn_rqst * packet);
int handle_stop_ctrl_conn_rply(struct control_struct * ctrl, struct pptp_stop_ctrl_conn_rply * packet);
int handle_echo_rqst(struct control_struct * ctrl, struct pptp_echo_rqst * packet);
int handle_echo_rply(struct control_struct * ctrl, struct pptp_echo_rply * packet);
int handle_out_call_rqst(struct control_struct * ctrl, struct pptp_out_call_rqst * packet);
int handle_out_call_rply(struct control_struct * ctrl, struct pptp_out_call_rply * packet);
int handle_in_call_rqst(struct control_struct * ctrl, struct pptp_in_call_rqst * packet);
int handle_in_call_rply(struct control_struct * ctrl, struct pptp_in_call_rply * packet);
int handle_in_call_conn(struct control_struct * ctrl, struct pptp_in_call_connect * packet);
int handle_call_clr_rqst(struct control_struct * ctrl, struct pptp_call_clr_rqst * packet);
int handle_call_disconn_ntfy(struct control_struct * ctrl, struct pptp_call_disconn_ntfy * packet);
int handle_wan_err_ntfy(struct control_struct * ctrl, struct pptp_wan_err_ntfy * packet);
int handle_set_link_info(struct control_struct * ctrl, struct pptp_set_link_info * packet);
int send_packet(struct control_struct * ctrl, void * packet);
void * prepare_call_close_packet(struct ppp_struct * p, int result_code);

/* gre.c */
int gre_init(struct control_struct * ctrl);
int read_gre_packet(struct control_struct * ctrl);
int send_gre_packet(struct control_struct * ctrl, struct ppp_struct * ppp, char * buf, int len);
void gre_set_timeout( struct control_struct *ctrl );
int gre_timeout(struct control_struct * ctrl);

/* ppp.c */
int conf_ppp( char *filename );
struct ppp_struct * new_ppp(struct control_struct * c);
void release_ppp( struct ppp_struct *p );
void unlink_and_release_ppp(struct ppp_struct *** pp, u_int16_t call_id);
int read_ppp_packet(struct control_struct * ctrl, struct ppp_struct * ppp);
int send_ppp_packet(struct control_struct * ctrl, struct ppp_struct * ppp, char * in, int in_len);

#endif /* _PROTOTYPES_H */
